import { Express } from 'express';
import EventEmitter from 'events';
export declare abstract class BaseApplication {
    app: Express;
    constructor(app: Express);
    private static eventEmitter;
    private static instance;
    static init: <T extends BaseApplication>(application: T) => T;
    static getInstance: () => BaseApplication;
    setUp: () => Promise<void>;
    initialiseEventEmitter: () => void;
    static getEventEmitter: () => EventEmitter;
    /**
     * ! we encourage you not to invoke this function unless you have a deep understanding of how MEN MVC framework works
     */
    static clearEventEmitter: () => void;
    /**
     * ! we encourage you not to invoke this function unless you have a deep understanding of how MEN MVC framework works
     */
    static clearInstance: () => void;
    abstract initialise: () => Promise<void> | void;
    abstract initialisePreMiddlewares: () => Promise<void> | void;
    abstract registerRoutes: () => Promise<void> | void;
    abstract initialisePostMiddlewares: () => Promise<void> | void;
    abstract start: () => void;
}
